﻿Public Class TVerseny
    Private Const Szünet As Integer = 500 ' várakozás ezredmásodpercben a lépések között
    Public Pálya As TPálya
    Public Győztesek As SortedSet(Of Integer)
    Private VersenyzőkSzáma As Integer ' a versenyzők száma
    Private Versenyzők() As TVersenyző

    Public Sub Start()
        Console.Title = "Futóverseny"
        ' Beolvassuk a versenyzők számát:
        Console.Write("A versenyzők száma (<" & Console.LargestWindowHeight - 9 & "): ")
        VersenyzőkSzáma = Console.ReadLine()
        ' Méretezzük a versenyzőket tartalmazó tömböt és létrehozzuk a versenyzőobjektumokat (tömbelemek):
        ReDim Versenyzők(VersenyzőkSzáma)
        For I = 1 To VersenyzőkSzáma
            Versenyzők(I) = New TVersenyző
            Versenyzők(I).Létrehoz(I)
            Vár(20)
            ' A várakozásra azért van szükség, mert ha a versenyzők nagyon gyorsan egymás után hozzák létre a Random objektumokat, akkor azonos lesz a sorozatok kezdőértéke.
            ' (A kezdőértéket a rendszeridőből határozza meg.)
        Next
        ' Létrehozzuk a pályaobjektumot:
        Pálya = New TPálya
        Pálya.Létrehoz(VersenyzőkSzáma)
        ' Elindítjuk a versenyt:
        Győztesek = New SortedSet(Of Integer)
        Futás()
        ' Kiírjuk a győzteseket:
        Eredmény()
        Console.Write("(Enter: kilép)")
        Console.ReadLine()
    End Sub

    Private Sub Futás()
        Do
            Console.CursorTop = 0
            For I = 1 To VersenyzőkSzáma
                Versenyzők(I).Fut(Me)
            Next
            Vár(Szünet)
        Loop While Győztesek.Count = 0
        Console.ForegroundColor = ConsoleColor.Gray
        Console.WriteLine("Vége a versenynek.")
    End Sub

    Private Sub Eredmény()
        Console.Write("Győzött: ")
        For Each Elem In Győztesek
            Console.Write(Elem & " ")
        Next
        Console.WriteLine()
    End Sub

    Private Sub Vár(ByVal Időtartam As Integer)
        Threading.Thread.Sleep(Időtartam)
    End Sub
End Class

