﻿Public Class TEllipszis : Inherits TKör
    Implements ILapult

    Public Property B As Single

    Public Property Név1 As String Implements ILapult.Név
        Get
            Név1 = Név
        End Get
        Set(ByVal value As String)
            Név = Név1
        End Set
    End Property

    Public Function Lapultság() As Single Implements ILapult.Lapultság
        Lapultság = 1 - Math.Min(A, B) / Math.Max(A, B)
    End Function

    Public Sub New(ByVal X As Single, ByVal Y As Single, ByVal A As Single, ByVal B As Single)
        MyBase.New(X, Y, A)
        Név = "Ellipszis"
        Me.B = B
    End Sub

    Public Overrides Function Terület() As Single
        Terület = A * B * Pi
    End Function

    Public Overrides Function ToString() As String
        Dim Temp As String
        Temp = MyBase.ToString
        Temp &= "B = " & B & vbNewLine
        Temp &= "Lapultság: " & Lapultság() & vbNewLine
        ToString = Temp
    End Function
End Class
