﻿Public Class Form1
    Dim MelyikPizza, MelyikFeltét, MelyikSzósz As String
    Dim Szósz() As String = {"bolognai", "tartár", "ketchup", "barbeque"}
    Dim Választógomb(Szósz.GetUpperBound(0)) As RadioButton
    Dim Pizza() As String = {"Uránusz", "Himalája", "Carmen", "Holdsugár"}

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' A választógombokat futásidőben hozzuk létre:
        For I = 0 To Szósz.Count - 1
            Választógomb(I) = New RadioButton
            Választógomb(I).Text = Szósz(I)
            Választógomb(I).Left = 20
            Választógomb(I).Top = 20 + 30 * I
            AddHandler Választógomb(I).Click, AddressOf Szószok
            GroupBox1.Controls.Add(Választógomb(I))
        Next

        ' A lenyíló lista feltöltése futásidőben:
        For Each Elem In Pizza
            ComboBox1.Items.Insert(0, Elem)
        Next
        ComboBox1.Sorted = True

        ' A menüsor és az állapotsor tulajdonságai:
        PizzafajtaToolStripMenuItem.Checked = True
        FeltétToolStripMenuItem.Checked = True
        SzószToolStripMenuItem.Checked = True
        ToolStripStatusLabel1.Text = ""
        ToolStripProgressBar1.Value = 10

        MelyikPizza = ""
        MelyikFeltét = ""
        MelyikSzósz = ""

        Button1.Enabled = False
    End Sub

    Sub Szószok(ByVal sender As System.Object, ByVal e As System.EventArgs)
        MelyikSzósz = sender.Text
        Kiír()
    End Sub

    Private Sub CheckBox2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox2.CheckedChanged
        Feltétek()
    End Sub

    Private Sub CheckBox3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox3.CheckedChanged
        Feltétek()
    End Sub

    Private Sub CheckBox4_CheckedChanged_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox4.CheckedChanged
        Feltétek()
    End Sub

    Sub Feltétek()
        MelyikFeltét = ""
        If CheckBox2.Checked Then
            MelyikFeltét &= CheckBox2.Text & ", "
        End If
        If CheckBox3.Checked Then
            MelyikFeltét &= CheckBox3.Text & ", "
        End If
        If CheckBox4.Checked Then
            MelyikFeltét &= CheckBox4.Text & ", "
        End If
        If MelyikFeltét <> "" Then
            MelyikFeltét = MelyikFeltét.Substring(0, MelyikFeltét.Length - 2) ' levágjuk az utolsó vesszőt és szóközt
        End If
        Kiír()
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        MelyikPizza = ComboBox1.SelectedItem
        Kiír()
    End Sub

    Private Sub KilépésAltF4ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles KilépésAltF4ToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub AProgramNévjegyeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AProgramNévjegyeToolStripMenuItem.Click
        MsgBox("Pizzarendelés", , "Pizzafutár")
    End Sub

    Private Sub FeltétToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FeltétToolStripMenuItem.Click
        FeltétToolStripMenuItem.Checked = Not FeltétToolStripMenuItem.Checked
        Label1.Visible = Not Label1.Visible
        CheckBox2.Visible = Not CheckBox2.Visible
        CheckBox3.Visible = Not CheckBox3.Visible
        CheckBox4.Visible = Not CheckBox4.Visible
        If Not FeltétToolStripMenuItem.Checked Then
            CheckBox2.Checked = False
            CheckBox3.Checked = False
            CheckBox4.Checked = False
            MelyikFeltét = ""
        End If
        Kiír()
    End Sub

    Private Sub SzószToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SzószToolStripMenuItem.Click
        SzószToolStripMenuItem.Checked = Not SzószToolStripMenuItem.Checked
        If SzószToolStripMenuItem.Checked Then
            GroupBox1.Visible = True
        Else
            GroupBox1.Visible = False ' lehetett volna Not-tal is
            For I = 0 To Szósz.Count - 1
                Választógomb(I).Checked = False
            Next
            MelyikSzósz = ""
        End If
        Kiír()
    End Sub

    Sub Kiír()
        ToolStripStatusLabel1.Text = MelyikPizza & " - " & MelyikSzósz & " - " & MelyikFeltét
        ToolStripProgressBar1.Value = 10
        If MelyikPizza <> "" Then
            ToolStripProgressBar1.Value += 30
        End If
        If MelyikSzósz <> "" Or Not SzószToolStripMenuItem.Checked Then
            ToolStripProgressBar1.Value += 30
        End If
        If MelyikFeltét <> "" Or Not FeltétToolStripMenuItem.Checked Then
            ToolStripProgressBar1.Value += 30
        End If
        If ToolStripProgressBar1.Value = 100 Then
            Button1.Enabled = True
        Else
            Button1.Enabled = False
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        MsgBox("Pizzarendelés: " & MelyikPizza & " - " & MelyikSzósz & " - " & MelyikFeltét, , "Pizzafutár")
    End Sub
End Class
