﻿' Gyorsrendezés (quick sort)

Public Class Form1
    Dim Tömb() As Integer

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Label1.Text = ""
        Feltölt()
        Kiír("Eredeti tömb:")

        Gyorsrendezés(1, Tömb.GetUpperBound(0), Tömb)

        Kiír("Rendezett tömb:")
    End Sub

    Sub Gyorsrendezés(ByVal Első As Integer, ByVal Utolsó As Integer, ByRef Tömb() As Integer)
        ' A Tömb paramétert csak a teljesség kedvéért használjuk, itt nem lenne rá szükség
        Dim Őrszem As Integer
        Szétválogat(Első, Utolsó, Őrszem, Tömb)
        If Első < Őrszem - 1 Then Gyorsrendezés(Első, Őrszem - 1, Tömb)
        If Őrszem + 1 < Utolsó Then Gyorsrendezés(Őrszem + 1, Utolsó, Tömb)
    End Sub

    Sub Szétválogat(ByVal Első As Integer, ByVal Utolsó As Integer, ByRef Darab As Integer, ByRef Tömb() As Integer)
        Dim Temp As Integer

        Temp = Tömb(Első)
        Do While Első < Utolsó
            Do While Első < Utolsó And Tömb(Utolsó) > Temp
                Utolsó -= 1
            Loop
            If Első < Utolsó Then
                Tömb(Első) = Tömb(Utolsó)
                Első = Első + 1
                Do While Első < Utolsó And Tömb(Első) <= Temp
                    Első = Első + 1
                Loop
                If Első < Utolsó Then
                    Tömb(Utolsó) = Tömb(Első)
                    Utolsó -= 1
                End If
            End If
        Loop
        Tömb(Első) = Temp
        Darab = Első ' most nincs szükség a feltételes elágazásra (miért?)
    End Sub

    Sub Feltölt()
        Dim Vélszám As New Random
        Dim MaxIndex As Integer

        MaxIndex = Vélszám.Next(5, 10)
        ReDim Tömb(MaxIndex)
        For I = 1 To MaxIndex
            Tömb(I) = Vélszám.Next(1, 20)
        Next
    End Sub

    Sub Kiír(ByVal Szöveg As String)
        Label1.Text &= Szöveg & vbNewLine
        For I = 1 To Tömb.GetUpperBound(0)
            Label1.Text &= Tömb(I) & " "
        Next
        Label1.Text &= vbNewLine & vbNewLine
    End Sub
End Class

