﻿Imports System.IO

Public Class Form1
    Structure TDiák
        Dim Név As String
        Dim Kulcs As Integer ' a diák magassága (nevezhetnénk így is a mezőt)
    End Structure

    Const MaxKulcs = 250 ' ennél magasabb diák nincs (cm-ben mérve)
    Const Út As String = "Diákok.txt"
    Dim N As Integer
    Dim Tömb(200), Újtömb(200) As TDiák


    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Feltölt()
        Kiír(Tömb, "Eredeti tömb:", Label1)

        Rendez(Tömb, Újtömb)

        Kiír(Újtömb, "Rendezett tömb:", Label2)
    End Sub

    Sub Rendez(ByVal Tömb() As TDiák, ByRef ÚjTömb() As TDiák)
        Dim Darab(MaxKulcs)
        Dim I As Integer

        Array.Clear(Darab, 0, Darab.Length)

        For I = 1 To N
            Darab(Tömb(I).Kulcs) += 1
        Next
        For I = 2 To Darab.GetUpperBound(0)
            Darab(I) += Darab(I - 1)
        Next
        For I = N To 1 Step -1
            ÚjTömb(Darab(Tömb(I).Kulcs)) = Tömb(I)
            Darab(Tömb(I).Kulcs) -= 1
        Next
    End Sub

    Sub Feltölt()
        Dim Fájlbe As StreamReader
        Dim Temp() As String
        Dim Sor As String
        Dim I As Integer

        Fájlbe = New StreamReader(Út)
        N = 0
        Do While Not Fájlbe.Peek
            Sor = Fájlbe.ReadLine
            Temp = Strings.Split(Sor, " ")
            N += 1
            Tömb(N).Név = Temp(0) & " " & Temp(1)
            Tömb(N).Kulcs = CInt(Temp(2))
        Loop
        Fájlbe.Close()
        Fájlbe.Dispose()
    End Sub

    Sub Kiír(ByVal Tömb() As TDiák, ByVal Szöveg As String, ByVal Címke As Label)
        Dim Temp As String
        Temp = Szöveg & vbNewLine
        For I = 1 To N
            Temp &= Tömb(I).Kulcs & " " & Tömb(I).Név & vbNewLine
        Next
        Címke.Text = Temp & vbNewLine
    End Sub
End Class

