﻿Imports System.IO

Public Class Form1
    Dim Tábla(,) As Char
    Dim MaxSor, MaxOszlop As Integer ' a program négyzet alakú táblával dolgozik, de általánosítható téglalap alakúra is
    Dim Sor, Oszlop As Integer
    Dim Kész As Boolean

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Label1.Text = ""
        Feltölt()
        Kiír()

        Sor = 1
        Oszlop = 1
        Útkeresés(Sor, Oszlop, Kész)
        If Kész Then
            Kiír()
        Else
            Label1.Text &= "Nincs megoldás."
        End If

        TextBox1.Focus()
        TextBox1.SelectAll()
    End Sub

    Sub Útkeresés(ByVal Sor, ByVal Oszlop, ByRef Kész) ' Visszalépéses keresés
        Tábla(Sor, Oszlop) = "O"
        Kész = (Sor = MaxSor And Oszlop = MaxOszlop)
        If Not Kész And Tábla(Sor, Oszlop + 1) = " " Then ' jobbra lépünk
            Útkeresés(Sor, Oszlop + 1, Kész)
        End If
        If Not Kész And Tábla(Sor + 1, Oszlop) = " " Then ' lefelé lépünk
            Útkeresés(Sor + 1, Oszlop, Kész)
        End If
        If Not Kész Then ' visszalépünk
            Tábla(Sor, Oszlop) = " " ' a kiírás miatt kell (különben benne maradna az O)
            If Tábla(Sor, Oszlop - 1) = "O" Then ' balról jöttünk
                Oszlop -= 1
            Else ' fentről jöttünk
                Sor -= 1
            End If
        End If
    End Sub

    Sub Feltölt()
        Dim Fájlbe As StreamReader
        Dim Sor, Út As String
        Dim I, J As Integer

        Út = TextBox1.Text
        Fájlbe = New StreamReader(Út)
        MaxSor = Fájlbe.ReadLine
        MaxOszlop = MaxSor
        ReDim Tábla(MaxSor + 1, MaxOszlop + 1)
        I = 1
        Do While Not Fájlbe.Peek
            Sor = Fájlbe.ReadLine
            For J = 0 To Sor.Length - 1
                Select Case Sor(J)
                    Case "." : Tábla(I, J + 1) = " "
                    Case "x" : Tábla(I, J + 1) = "X"
                End Select
            Next
            I += 1
        Loop
        Fájlbe.Close()
        Fájlbe.Dispose()
        For I = 0 To MaxSor + 1 ' a szélek feltöltése
            Tábla(0, I) = "X"
            Tábla(MaxSor + 1, I) = "X"
            Tábla(I, 0) = "X"
            Tábla(I, MaxOszlop + 1) = "X"
        Next
        ' Bejárat, kijárat:
        Tábla(1, 0) = " "
        Tábla(MaxSor, MaxOszlop + 1) = " "
    End Sub

    Sub Kiír()
        Dim Temp As String

        Temp = ""
        For I = 0 To MaxSor + 1
            For J = 0 To MaxOszlop + 1
                Temp &= Tábla(I, J)
            Next
            Temp &= vbNewLine
        Next
        Label1.Text &= Temp & vbNewLine
    End Sub
End Class