﻿' Kombinatorikai algoritmusok
' Ismétléses permutációk

Public Class Form1
    Dim I, K, L, N, Db, Temp As Integer
    Dim Elem(100) As Integer
    Dim Sorozat As String
    Dim Elemek() As String
    Dim Megoldás As System.Text.StringBuilder ' gyorsabb, mintha sztringet használnánk

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Megoldás = New System.Text.StringBuilder("Az elemek ismétléses permutációi:" & vbNewLine)
        RichTextBox1.Text = Megoldás.ToString()

        ' Az elemeket tartalmazó tömb feltöltése
        Sorozat = TextBox1.Text
        Elemek = Sorozat.Split(" ")
        N = Elemek.GetUpperBound(0) + 1
        For I = 1 To N
            Elem(I) = CInt(Elemek(I - 1))
        Next

        ' A permutációk meghatározása és kiírása:
        Db = 0
        Do
            ' Kiírás (az eredeti sorrenddel kezdjük):
            Db += 1
            Megoldás.AppendFormat("{0,3}.: ", Db)
            For I = 1 To N
                Megoldás.Append(Elem(I))
            Next
            Megoldás.Append(vbNewLine)

            ' Megkeressük az a legnagyobb K-t, amelyre Elem(K) < Elem(K+1)
            ' (ha nincs ilyen, akkor nincs több permutáció):
            K = N - 1
            Do While K > 0 AndAlso Elem(K) >= Elem(K + 1)
                K -= 1
            Loop
            If K > 0 Then
                ' Megkeressük azt a legnagyobb L-et, amelyre Elem(K) < Elem(L)
                ' (biztosan van ilyen!):
                L = N
                Do While Elem(K) >= Elem(L)
                    L -= 1
                Loop
                ' Felcseréljük a K-adik és az L-edik elemet:
                Temp = Elem(K)
                Elem(K) = Elem(L)
                Elem(L) = Temp
                ' A K+1-edik elemtől a végéig megfordítjuk a tömbelemek sorrendjét:
                Array.Reverse(Elem, K + 1, N - K)
            End If
        Loop While K > 0

        ' Kiírjuk a megoldásokat:
        RichTextBox1.Text = Megoldás.ToString()
        TextBox1.Focus()
        TextBox1.SelectAll()
    End Sub
End Class