﻿' Kombinatorikai algoritmusok
' Ismétlés nélküli variációk

Public Class Form1
    Dim I, Db, N, K As Integer
    Dim Megold(100) As Integer
    Dim Van As Boolean
    Dim Megoldás As System.Text.StringBuilder

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        N = CInt(TextBox1.Text)
        K = CInt(TextBox2.Text)
        Megoldás = New System.Text.StringBuilder(N & " elem " & K & ". osztályú ismétlés nélküli variációi:" & vbNewLine)
        RichTextBox1.Text = Megoldás.ToString()

        ÖsszesMegoldás()

        RichTextBox1.Text = Megoldás.ToString()
        TextBox1.Focus()
        TextBox1.SelectAll()
    End Sub

    Sub ÖsszesMegoldás()
        Dim I, Melyik As Integer

        Array.Clear(Megold, 0, Megold.Length)
        I = 1
        Db = 0
        Do While I >= 1
            ElemetKeres(I, Van, Melyik)
            If Van Then
                Megold(I) = Melyik
                I += 1
            Else
                Megold(I) = 0
                I -= 1
            End If
            Van = I > K
            If Van Then
                Db += 1
                Megoldás.AppendFormat("{0,3}.: ", Db)
                For J = 1 To K
                    Megoldás.Append(Megold(J))
                Next
                Megoldás.Append(vbNewLine)
                I -= 1
            End If
        Loop
    End Sub

    Sub ElemetKeres(ByVal I As Integer, ByRef Van As Boolean, ByRef Melyik As Integer)
        Melyik = Megold(I) + 1
        Do While (Melyik <= N) And NemJó(I, Melyik)
            Melyik += 1
        Loop
        Van = (Melyik <= N)
    End Sub

    Function NemJó(ByVal I As Integer, ByVal Melyik As Integer) As Boolean
        Dim J As Integer
        J = 1
        Do While J < I And Megfelelő(Melyik, J)
            J += 1
        Loop
        NemJó = (J < I)
    End Function

    Function Megfelelő(ByVal Melyik As Integer, ByVal J As Integer)
        Megfelelő = (Melyik <> Megold(J))
    End Function
End Class
