﻿' Kombinatorikai algoritmusok
' Ismétlés nélküli kombinációk

Public Class Form1
    Dim I, Db, N, K As Integer
    Dim Megold(100) As Integer
    Dim Van As Boolean

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        N = CInt(TextBox1.Text)
        K = CInt(TextBox2.Text)
        RichTextBox1.Text = N & " elem " & K & ". osztályú ismétlés nélküli kombinációi:" & vbNewLine

        ÖsszesMegoldás()

        TextBox1.Focus()
        TextBox1.SelectAll()
    End Sub

    Sub ÖsszesMegoldás()
        Dim I, J, Melyik As Integer

        Array.Clear(Megold, 0, Megold.Length)
        I = 1
        Db = 0
        Do While I >= 1
            ElemetKeres(I, Van, Melyik)
            If Van Then
                Megold(I) = Melyik
                I += 1
            Else
                Megold(I) = 0
                I -= 1
            End If
            If I > K Then
                Db += 1
                RichTextBox1.Text &= String.Format("{0,3}.: ", Db)
                For J = 1 To K
                    RichTextBox1.Text &= Megold(J)
                Next
                RichTextBox1.Text &= vbNewLine
                I -= 1
            End If
        Loop
    End Sub

    Sub ElemetKeres(ByVal I As Integer, ByRef Van As Boolean, ByRef Melyik As Integer)
        Melyik = Megold(I) + 1
        Do While (Melyik <= N) And NemJó(I, Melyik)
            Melyik += 1
        Loop
        Van = (Melyik <= N)
    End Sub

    Function NemJó(ByVal I As Integer, ByVal Melyik As Integer) As Boolean
        NemJó = (I > 1 AndAlso Megold(I - 1) >= Melyik)
    End Function
End Class
