﻿' Kártyakeverés
' A képfájlokat először felvettük az erőforrások közé (Project/Properties/Add resource),
' majd a My.Resources.ResourceManager.GetObject metódussal rendeltük hozzá a PictureBox Image tulajdonságához.
' (A számjeggyel kezdődő erőforrásnevek elé aláhúzásjel kerül.)

Public Class Form1
    Const N As Integer = 52
    Const Szélesség As Integer = 71
    Dim Lap As Dictionary(Of Integer, Integer)
    Dim Kártya(N) As PictureBox
    Dim I, K As Integer
    Dim Vélszám As Random = New Random

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        ' Töröljük az előzőleg megjelenített lapokat.
        ' (A Controls kollekció 0-2 indexű eleme a Label1, a TextBox1 és a Button1, a többi töröljük.)
        For I = 3 To Me.Controls.Count - 1
            Me.Controls.RemoveAt(3)
        Next

        K = TextBox1.Text
        Oszt()
        Kiír()
        TextBox1.Focus()
        TextBox1.SelectAll()
    End Sub

    Sub Oszt()
        Dim J As Integer

        Lap.Clear()
        For I = 1 To K
            J = Vélszám.Next(I, N + 1)
            Csere(I, J)
        Next
    End Sub

    Sub Csere(ByVal I As Integer, ByVal J As Integer)
        Dim Temp As Integer

        If Not Lap.ContainsKey(I) Then
            Lap.Add(I, I)
        End If
        If Not Lap.ContainsKey(J) Then
            Lap.Add(J, J)
        End If
        ' Csere:
        Temp = Lap.Item(I)
        Lap.Item(I) = Lap.Item(J)
        Lap.Item(J) = Temp
    End Sub

    Sub Kiír()
        For I = 1 To K
            Kártya(I).Image = My.Resources.ResourceManager.GetObject("_" & Lap.Item(I))
            Kártya(I).Left = I * (Szélesség + 2) - 50
            Me.Controls.Add(Kártya(I))
        Next
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Lap = New Dictionary(Of Integer, Integer)
        For I = 1 To N
            Lap(I) = I
        Next
        For I = 1 To N
            Kártya(I) = New PictureBox
            Kártya(I).SizeMode = PictureBoxSizeMode.AutoSize
            Kártya(I).Top = 60
        Next
    End Sub
End Class


