﻿' Mohó algoritmus
' Teremfoglalás
' Véletlen időintervallumok generálásával

Public Class Form1
    ' A rendezvények kezdetének és végének időpontját egész számokkal reprezentáljuk.
    ' A Vég tömb szerint rendezve kell megadni az időpontokat!
    Dim Kezd() As Integer ' az események kezdetének időpontjai
    Dim Vég() As Integer  ' az események végének időpontjai (nagyság szerint növekvő sorba rendezve!)
    Dim Megoldás(100) As Integer ' a kiválasztott események sorszámai
    Dim I, N, Utolsó, Db As Integer
    Dim Vélszám As Random = New Random

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Adatok()
        N = Kezd.GetUpperBound(0)
        Label2.Text = "Időintervallumok" & vbNewLine
        For I = 1 To N
            Label2.Text &= String.Format("{0,2}.: {1,2} - {2,2}", I, Kezd(I), Vég(I)) & vbNewLine
        Next

        ' Iteratív megoldás:
        Megoldás(1) = 1
        Db = 1
        Utolsó = 1
        For I = 2 To N
            If Kezd(I) >= Vég(Utolsó) Then
                Db += 1
                Megoldás(Db) = I
                Utolsó = I
            End If
        Next
        Label1.Text = "Iteratív megoldás:" & vbNewLine
        Kiír()

        ' Rekurzív megoldás:
        Db = 0
        Kiválaszt(0)
        Label1.Text &= "Rekurzív megoldás:" & vbNewLine
        Kiír()
    End Sub

    Sub Kiválaszt(ByVal I As Integer)
        ' rekurzív megoldás
        Dim Utolsó As Integer

        Utolsó = I + 1
        Do While Utolsó <= N AndAlso Kezd(Utolsó) < Vég(I)
            Utolsó += 1
        Loop
        If Utolsó <= N Then
            Db += 1
            Megoldás(Db) = Utolsó
            Kiválaszt(Utolsó)
        End If
    End Sub

    Sub Adatok()
        Dim Vége As Integer
        Dim Időpont(1) As Integer

        Vége = Vélszám.Next(10, 24)
        N = Vélszám.Next(1, 20)
        ReDim Kezd(N)
        ReDim Vég(N)
        For I = 1 To N
            Do
                Időpont(0) = Vélszám.Next(1, Vége + 1)
                Időpont(1) = Vélszám.Next(1, Vége + 1)
                Kezd(I) = Időpont.Min
                Vég(I) = Időpont.Max
            Loop Until Kezd(I) < Vég(I)
        Next
        Array.Sort(Vég, Kezd) ' együtt rendezi a két tömböt, a Vég elemei szerint növekvő sorrendben
    End Sub

    Sub Kiír()
        Dim Temp As Integer

        For I = 1 To Db
            Temp = Megoldás(I)
            Label1.Text &= String.Format("{0,2}. rendezvény, ideje: {1,2} - {2,2}", Temp, Kezd(Temp), Vég(Temp)) & vbNewLine
        Next
        Label1.Text &= vbNewLine
    End Sub
End Class
