﻿' Mohó algoritmus
' Fotózás

Public Class Form1
    Dim Vége As Integer      ' a legkésőbbi időpont (időpontok 1-től Vége-ig)
    Dim N As Integer         ' a vendégek száma
    Dim Jön() As Integer     ' a vendégek érkezési időpontjai
    Dim Megy() As Integer    ' a vendégek távozási időpontjai
    Dim LegkésőbbiÉrkezés() As Integer ' az I időpontban távozók legkésőbbi érkezési ideje (lásd a tankönyvet)
    Dim Fotó() As Integer
    Dim I, J, K, UtolsóFotó, Darab As Integer
    Dim Vélszám As New Random

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Adatok()

        ReDim LegkésőbbiÉrkezés(Vége)
        ReDim Fotó(Vége)

        ' A Mettől tömb feltöltése
        Array.Clear(LegkésőbbiÉrkezés, 0, Vége)
        For I = 1 To N
            If Jön(I) > LegkésőbbiÉrkezés(Megy(I)) Then
                LegkésőbbiÉrkezés(Megy(I)) = Jön(I)
            End If
        Next

        ' Az időpontok választása:
        UtolsóFotó = 0
        Darab = 0
        For I = 1 To Vége
            If LegkésőbbiÉrkezés(I) > 0 And UtolsóFotó < LegkésőbbiÉrkezés(I) Then
                ' volt távozás és az utolsó fényképezés óta jött vendég, ezért készítünk fényképet:
                Darab += 1
                Fotó(Darab) = I
                UtolsóFotó = I
            End If
        Next

        Kiír()

    End Sub

    Sub Adatok()
        Dim Temp(1) As Integer
        Vége = Vélszám.Next(10, 24)
        N = Vélszám.Next(1, 10)
        ReDim Jön(N)
        ReDim Megy(N)
        ReDim LegkésőbbiÉrkezés(Vége)
        ReDim Fotó(Vége)
        For I = 1 To N
            Temp(0) = Vélszám.Next(1, Vége + 1)
            Temp(1) = Vélszám.Next(1, Vége + 1)
            Jön(I) = Temp.Min
            Megy(I) = Temp.Max
        Next
    End Sub

    Sub Kiír()
        Dim H As SortedSet(Of Integer)
        Dim Elem As Integer
        H = New SortedSet(Of Integer)
        Label1.Text = vbNewLine
        Label2.Text = "A vendégek száma: " & N & vbNewLine
        K = 1
        For I = 1 To Vége
            If Fotó(K) = I Then
                Label1.Text &= K & ". fotó --"
                For J = 1 To N
                    If Jön(J) <= I And Megy(J) >= I Then
                        H.Add(J)
                    End If
                Next
                K += 1
            End If
            Label1.Text &= vbNewLine
            Label2.Text &= String.Format("T={0,2}: vendégek: ", I)
            For J = 1 To N
                If Jön(J) <= I And Megy(J) >= I Then
                    Label2.Text &= J & " "
                Else
                    Label2.Text &= "  "
                End If
            Next
            Label2.Text &= vbNewLine
        Next
        Label2.Text &= vbNewLine & "Lefényképezett vendégek: "
        For Each Elem In H
            Label2.Text &= Elem & " "
        Next
    End Sub
End Class
