﻿Public Class Form1
    Dim Számok(100) As Integer
    Dim Vélszám As New Random
    Dim Végpont As Integer

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Label1.Text = ""
        Utatgenerál()
        Label2.Text = "Út (Rekurzív): "
        BejárRekurzív(Végpont)
        Label2.Text &= vbNewLine & "Út (Iteratív): "
        BejárIteratív(Végpont)
    End Sub

    Sub BejárRekurzív(ByVal Cella As Integer)
        If Cella <> 1 Then
            BejárRekurzív(Számok(Cella))
        End If
        Label2.Text &= Cella & " "
    End Sub

    Sub BejárIteratív(ByVal Cella As Integer)
        Dim Verem As Stack(Of Integer) = New Stack(Of Integer)

        ' Pakolás a verembe
        Do While Cella <> 1
            Verem.Push(Cella)
            Cella = Számok(Cella)
        Loop
        Verem.Push(Cella)
        ' Feldolgozás
        Do While Verem.Count > 0
            Label2.Text &= Verem.Pop & " "
        Loop
    End Sub

    Sub Utatgenerál()
        Dim Következő, Aktuális As Integer
        Array.Clear(Számok, 0, 101)

        ' Lépések
        Label1.Text &= "Út: "
        Aktuális = 1
        Számok(1) = -1
        Következő = Vélszám.Next(1, 101)
        Do While Számok(Következő) = 0
            Label1.Text &= Aktuális & " "
            Számok(Következő) = Aktuális
            Aktuális = Következő
            Következő = Vélszám.Next(1, 101)
        Loop
        Végpont = Aktuális
        Label1.Text &= Végpont & vbNewLine & vbNewLine
        ' A táblázat kiírása
        Label1.Text &= "Táblázat:" & vbNewLine & "    "
        For Aktuális = 1 To 10
            Label1.Text &= String.Format("{0,4}", Aktuális)
        Next
        Label1.Text &= vbNewLine
        For Aktuális = 1 To 100
            If Aktuális Mod 10 = 1 Then
                Label1.Text &= vbNewLine & String.Format("{0,3}:", Aktuális)
            End If
            Label1.Text &= String.Format("{0,4}", Számok(Aktuális))
        Next
    End Sub
End Class

