﻿' Kombinatorikai algoritmusok
' Ismétlés nélküli permutációk

Public Class Form1
    Dim Megold(100) As Integer
    Dim N, Db, I As Integer
    Dim Van As Boolean
    Dim Megoldás As System.Text.StringBuilder ' gyorsabb, mintha sztringet használnánk

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        N = CInt(TextBox1.Text)
        Db = 0
        Megoldás = New System.Text.StringBuilder(N & " elem ismétlés nélküli permutációi:" & vbNewLine)
        RichTextBox1.Text = Megoldás.ToString()

        ÖsszesMegoldás()

        RichTextBox1.Text = Megoldás.ToString()
        TextBox1.Focus()
        TextBox1.SelectAll()
    End Sub

    Sub ÖsszesMegoldás()
        Dim I, Melyik As Integer

        Array.Clear(Megold, 0, Megold.Length)
        I = 1
        Do While I >= 1
            ElemetKeres(I, Van, Melyik)
            If Van Then
                Megold(I) = Melyik
                I += 1
            Else
                Megold(I) = 0
                I -= 1
            End If

            Van = I > N
            If Van Then
                Db += 1
                Megoldás.AppendFormat("{0,5}.: ", Db)
                MegoldKiír()
                I -= 1
            End If
        Loop
    End Sub

    Sub ElemetKeres(ByVal I As Integer, ByRef Van As Boolean, ByRef Melyik As Integer)
        Melyik = Megold(I) + 1
        Do While Melyik <= N AndAlso NemJó(I, Melyik)
            Melyik += 1
        Loop
        Van = (Melyik <= N)
    End Sub

    Function NemJó(ByVal I As Integer, ByVal Melyik As Integer)
        Dim J As Integer
        J = 1
        Do While J < I And Megfelelő(Melyik, J)
            J += 1
        Loop
        NemJó = (J < I)
    End Function

    Function Megfelelő(ByVal Melyik As Integer, ByVal J As Integer)
        Megfelelő = (Melyik <> Megold(J))
    End Function

    Sub MegoldKiír()
        Dim I As Integer
        For I = 1 To N
            Megoldás.Append(Megold(I))
        Next
        Megoldás.Append(vbNewLine)
    End Sub
End Class
