﻿' Kártyakeverés
' A képfájlokat először felvettük az erőforrások közé (Project/Properties/Add resource),
' majd a My.Resources.ResourceManager.GetObject metódussal rendeltük hozzá a PictureBox Image tulajdonságához.
' (A számjeggyel kezdődő erőforrásnevek elé aláhúzásjel kerül.)
' A megjelenítéshez, módosításhoz célszerű inkább egy ImageList objektumot használni, lásd a Visual Basic súgóját.

Public Class Form1
    Const N As Integer = 52
    Const Szélesség As Integer = 71
    Dim Lap(N) As Integer
    Dim Kártya(N) As PictureBox
    Dim I, K As Integer
    Dim Vélszám As Random = New Random

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        ' Töröljük az előzőleg megjelenített lapokat:
        For I = 1 To K
            Me.Controls.Remove(Kártya(I))
        Next

        K = TextBox1.Text
        Oszt()
        Kiír()
        TextBox1.Focus()
        TextBox1.SelectAll()
    End Sub

    Sub Oszt()
        Dim J, Temp As Integer
        For I = 1 To K
            J = Vélszám.Next(I, N + 1)
            ' csere:
            Temp = Lap(I)
            Lap(I) = Lap(J)
            Lap(J) = Temp
        Next
    End Sub

    Sub Kiír()
        For I = 1 To K
            Kártya(I).Image = My.Resources.ResourceManager.GetObject("_" & Lap(I))
            Kártya(I).Left = I * (Szélesség + 2) - 50
            Me.Controls.Add(Kártya(I))
        Next
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        For I = 1 To N
            Lap(I) = I
        Next
        For I = 1 To N
            Kártya(I) = New PictureBox
            Kártya(I).SizeMode = PictureBoxSizeMode.AutoSize
            Kártya(I).Top = 60
        Next
    End Sub
End Class


