﻿' Dinamikus programozás
' Fizetés legkevesebb pénzérmével

Public Class Form1
    Dim Címlet() As Integer = {0, 1, 5, 10, 20, 25} ' 0 az elején, mert 1-től kezdjük az indexelést, rendezett tömb!
    ' Feltételezzük, hogy különbözőek az érmék, és szerepel közöttük az 1-es (mindig legyen megoldás)
    Dim Összeg, MaxI, MaxJ As Integer
    Dim Honnan(,) As String     ' honnan érkeztünk az (I,J) cellába
    Dim Táblázat(,) As Integer  ' táblázat a megoldás meghatározásához
    Dim I, J, Balra, Felette As Integer

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Összeg = TextBox1.Text

        Feltölt()

        ' A keresés algoritmusa:
        For I = 1 To MaxI
            For J = 1 To MaxJ
                If I < Címlet(J) Then
                    Táblázat(I, J) = Táblázat(I, J - 1)
                    Honnan(I, J) = "←"
                Else
                    Balra = Táblázat(I, J - 1)
                    Felette = Táblázat(I - Címlet(J), J) + 1
                    If Balra < Felette Then
                        Táblázat(I, J) = Balra
                        Honnan(I, J) = "←"
                    Else
                        Táblázat(I, J) = Felette
                        Honnan(I, J) = "↑"
                    End If
                End If
            Next
        Next

        Kiír()

        TextBox1.Focus()
        TextBox1.SelectAll()
    End Sub

    Sub Feltölt()
        ' A tömbök feltöltése
        Dim I, J
        MaxI = Összeg
        MaxJ = Címlet.GetUpperBound(0)
        ReDim Táblázat(MaxI, MaxJ)
        ReDim Honnan(MaxI, MaxJ)
        For J = 0 To MaxJ ' 0. sor
            Táblázat(0, J) = 0
        Next
        For I = 1 To MaxI ' 0. oszlop
            Táblázat(I, 0) = I
        Next
        For I = 0 To MaxI
            For J = 0 To MaxJ
                Honnan(I, J) = " "
            Next
        Next
    End Sub

    Sub Kiír()
        ' Az eredmények kiírása
        Dim Temp As String
        Dim I, J As Integer
        Dim Db(MaxJ) As Integer

        Label1.Text = "A szükséges pénzérmék száma: " & Táblázat(MaxI, MaxJ)

        Temp = "Megoldás:" & vbNewLine
        For J = 0 To MaxJ
            Db(J) = 0
        Next
        I = MaxI
        J = MaxJ
        Do While I > 0 And J > 0
            Select Case Honnan(I, J)
                Case "↑"
                    Db(J) += 1
                    I -= Címlet(J)
                Case "←"
                    J -= 1
            End Select
        Loop
        For J = 1 To MaxJ
            If Db(J) <> 0 Then
                Temp &= String.Format("{0,2} db {1,2} talléros", Db(J), Címlet(J)) & vbNewLine
            End If
        Next
        Temp &= vbNewLine

        Temp &= "A megoldáshoz vezető táblázat:" & vbNewLine & "    "
        For J = 0 To MaxJ
            Temp &= String.Format("{0,2}  ", Címlet(J))
        Next
        Temp &= vbNewLine
        For I = 0 To MaxI
            Temp &= String.Format("{0,2}: ", I)
            For J = 0 To MaxJ
                Temp &= String.Format("{0,2}  ", Táblázat(I, J))
            Next
            Temp &= vbNewLine
        Next
        Temp &= vbNewLine

        Temp &= "A Honnan táblázat:" & vbNewLine & "   "
        For J = 0 To MaxJ
            Temp &= String.Format("{0,2}  ", Címlet(J))
        Next
        Temp &= vbNewLine
        For I = 0 To MaxI
            Temp &= String.Format("{0,2}: ", I)
            For J = 0 To MaxJ
                Temp &= Honnan(I, J) & "   "
            Next
            Temp &= vbNewLine
        Next
        Temp &= vbNewLine

        Label2.Text = Temp
    End Sub
End Class
