﻿' Mohó algoritmus
' Teremfoglalás
' Adatok a tankönyvben szereplő példa alapján

Public Class Form1
    ' A rendezvények kezdetének és végének időpontját egész számokkal reprezentáljuk.
    ' A Vég tömb szerint rendezve kell megadni az időpontokat!
    Dim Kezd() As Integer = {0, 1, 3, 2, 5, 3, 5, 6, 8, 8, 2, 12}    ' az események kezdetének időpontjai
    Dim Vég() As Integer = {0, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14} ' az események végének időpontjai (növekvő sorrendbe rendezve!)
    Dim Megoldás(100) As Integer                                     ' a kiválasztott események sorszámai
    Dim I, N, Utolsó, Db As Integer

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        N = Kezd.GetUpperBound(0)

        ' Iteratív megoldás:
        Megoldás(1) = 1
        Db = 1
        Utolsó = 1
        For I = 2 To N
            If Kezd(I) >= Vég(Utolsó) Then
                Db += 1
                Megoldás(Db) = I
                Utolsó = I
            End If
        Next
        Label1.Text = "Iteratív megoldás:" & vbNewLine
        Kiír()

        ' Rekurzív megoldás:
        Db = 0
        Kiválaszt(0)
        Label1.Text &= "Rekurzív megoldás:" & vbNewLine
        Kiír()
    End Sub

    Sub Kiválaszt(ByVal I As Integer)
        ' rekurzív megoldás
        Dim Utolsó As Integer
        Utolsó = I + 1
        Do While Utolsó <= N AndAlso Kezd(Utolsó) < Vég(I)
            Utolsó += 1
        Loop
        If Utolsó <= N Then
            Db += 1
            Megoldás(Db) = Utolsó
            Kiválaszt(Utolsó)
        End If
    End Sub

    Sub Kiír()
        Dim Temp As Integer
        For I = 1 To Db
            Temp = Megoldás(I)
            Label1.Text &= String.Format("{0,2}. program, ideje: {1,2} - {2,2}", Temp, Kezd(Temp), Vég(Temp)) & vbNewLine
        Next
        Label1.Text &= vbNewLine
    End Sub
End Class
